import * as v from "@zwave-js/core/validation";
export function validateArgs_FirmwareUpdateMetaDataCCAPI_reportMetaData() {
    return (__decoratedMethod, { kind }) => {
        if (kind === "method") {
            return function reportMetaData(options) {
                v.assert(v.object({ kind: "parameter", name: "options" }, 'FirmwareUpdateMetaDataCCMetaDataReportOptions', { "manufacturerId": v.primitive({ kind: "property", name: "manufacturerId" }, "number"), "firmwareId": v.optional({ kind: "property", name: "firmwareId" }, v.primitive({ kind: "property", name: "firmwareId" }, "number")), "checksum": v.optional({ kind: "property", name: "checksum" }, v.primitive({ kind: "property", name: "checksum" }, "number")), "firmwareUpgradable": v.primitive({ kind: "property", name: "firmwareUpgradable" }, "boolean"), "maxFragmentSize": v.optional({ kind: "property", name: "maxFragmentSize" }, v.primitive({ kind: "property", name: "maxFragmentSize" }, "number")), "additionalFirmwareIDs": v.optional({ kind: "property", name: "additionalFirmwareIDs" }, v.array({ kind: "property", name: "additionalFirmwareIDs" }, 'number', v.primitive({ kind: "item", name: "additionalFirmwareIDs" }, "number"))), "hardwareVersion": v.optional({ kind: "property", name: "hardwareVersion" }, v.primitive({ kind: "property", name: "hardwareVersion" }, "number")), "continuesToFunction": v.optional({ kind: "property", name: "continuesToFunction" }, v.primitive({ kind: "property", name: "continuesToFunction" }, "boolean")), "supportsActivation": v.optional({ kind: "property", name: "supportsActivation" }, v.primitive({ kind: "property", name: "supportsActivation" }, "boolean")), "supportsResuming": v.optional({ kind: "property", name: "supportsResuming" }, v.primitive({ kind: "property", name: "supportsResuming" }, "boolean")), "supportsNonSecureTransfer": v.optional({ kind: "property", name: "supportsNonSecureTransfer" }, v.primitive({ kind: "property", name: "supportsNonSecureTransfer" }, "boolean")) })(options));
                return __decoratedMethod.call(this, options);
            };
        }
    };
}
export function validateArgs_FirmwareUpdateMetaDataCCAPI_requestUpdate() {
    return (__decoratedMethod, { kind }) => {
        if (kind === "method") {
            return function requestUpdate(options) {
                v.assert(v.oneOf({ kind: "parameter", name: "options" }, "FirmwareUpdateMetaDataCCRequestGetOptions", v.allOf({ kind: "parameter", name: "options" }, undefined, v.object({ kind: "parameter", name: "options" }, '<anonymous object>', { "manufacturerId": v.primitive({ kind: "property", name: "manufacturerId" }, "number"), "firmwareId": v.primitive({ kind: "property", name: "firmwareId" }, "number"), "checksum": v.primitive({ kind: "property", name: "checksum" }, "number") }), v.object({ kind: "parameter", name: "options" }, '<anonymous object>', { "firmwareTarget": v.primitive({ kind: "property", name: "firmwareTarget" }, "number"), "fragmentSize": v.primitive({ kind: "property", name: "fragmentSize" }, "number"), "activation": v.optional({ kind: "property", name: "activation" }, v.primitive({ kind: "property", name: "activation" }, "boolean")), "hardwareVersion": v.optional({ kind: "property", name: "hardwareVersion" }, v.primitive({ kind: "property", name: "hardwareVersion" }, "number")), "resume": v.optional({ kind: "property", name: "resume" }, v.primitive({ kind: "property", name: "resume" }, "boolean")), "nonSecureTransfer": v.optional({ kind: "property", name: "nonSecureTransfer" }, v.primitive({ kind: "property", name: "nonSecureTransfer" }, "boolean")) })), v.allOf({ kind: "parameter", name: "options" }, undefined, v.object({ kind: "parameter", name: "options" }, '<anonymous object>', { "manufacturerId": v.primitive({ kind: "property", name: "manufacturerId" }, "number"), "firmwareId": v.primitive({ kind: "property", name: "firmwareId" }, "number"), "checksum": v.primitive({ kind: "property", name: "checksum" }, "number") }), v.object({ kind: "parameter", name: "options" }, '<anonymous object>', {})))(options));
                return __decoratedMethod.call(this, options);
            };
        }
    };
}
export function validateArgs_FirmwareUpdateMetaDataCCAPI_respondToUpdateRequest() {
    return (__decoratedMethod, { kind }) => {
        if (kind === "method") {
            return function respondToUpdateRequest(options) {
                v.assert(v.object({ kind: "parameter", name: "options" }, 'FirmwareUpdateMetaDataCCRequestReportOptions', { "status": v.enum({ kind: "property", name: "status" }, "FirmwareUpdateRequestStatus"), "resume": v.optional({ kind: "property", name: "resume" }, v.primitive({ kind: "property", name: "resume" }, "boolean")), "nonSecureTransfer": v.optional({ kind: "property", name: "nonSecureTransfer" }, v.primitive({ kind: "property", name: "nonSecureTransfer" }, "boolean")) })(options));
                return __decoratedMethod.call(this, options);
            };
        }
    };
}
export function validateArgs_FirmwareUpdateMetaDataCCAPI_respondToDownloadRequest() {
    return (__decoratedMethod, { kind }) => {
        if (kind === "method") {
            return function respondToDownloadRequest(options) {
                v.assert(v.object({ kind: "parameter", name: "options" }, 'FirmwareUpdateMetaDataCCPrepareReportOptions', { "status": v.enum({ kind: "property", name: "status" }, "FirmwareDownloadStatus"), "checksum": v.primitive({ kind: "property", name: "checksum" }, "number") })(options));
                return __decoratedMethod.call(this, options);
            };
        }
    };
}
export function validateArgs_FirmwareUpdateMetaDataCCAPI_sendFirmwareFragment() {
    return (__decoratedMethod, { kind }) => {
        if (kind === "method") {
            return function sendFirmwareFragment(fragmentNumber, isLastFragment, data) {
                v.assert(v.primitive({ kind: "parameter", name: "fragmentNumber" }, "number")(fragmentNumber), v.primitive({ kind: "parameter", name: "isLastFragment" }, "boolean")(isLastFragment), v.uint8array({ kind: "parameter", name: "data" })(data));
                return __decoratedMethod.call(this, fragmentNumber, isLastFragment, data);
            };
        }
    };
}
export function validateArgs_FirmwareUpdateMetaDataCCAPI_activateFirmware() {
    return (__decoratedMethod, { kind }) => {
        if (kind === "method") {
            return function activateFirmware(options) {
                v.assert(v.object({ kind: "parameter", name: "options" }, 'FirmwareUpdateMetaDataCCActivationSetOptions', { "manufacturerId": v.primitive({ kind: "property", name: "manufacturerId" }, "number"), "firmwareId": v.primitive({ kind: "property", name: "firmwareId" }, "number"), "checksum": v.primitive({ kind: "property", name: "checksum" }, "number"), "firmwareTarget": v.primitive({ kind: "property", name: "firmwareTarget" }, "number"), "hardwareVersion": v.optional({ kind: "property", name: "hardwareVersion" }, v.primitive({ kind: "property", name: "hardwareVersion" }, "number")) })(options));
                return __decoratedMethod.call(this, options);
            };
        }
    };
}
//# sourceMappingURL=FirmwareUpdateMetaDataCC._validateArgs.js.map