import * as v from "@zwave-js/core/validation";
export function validateArgs_ScheduleEntryLockCCAPI_setEnabled() {
    return (__decoratedMethod, { kind }) => {
        if (kind === "method") {
            return function setEnabled(enabled, userId) {
                v.assert(v.primitive({ kind: "parameter", name: "enabled" }, "boolean")(enabled), v.optional({ kind: "parameter", name: "userId" }, v.primitive({ kind: "parameter", name: "userId" }, "number"))(userId));
                return __decoratedMethod.call(this, enabled, userId);
            };
        }
    };
}
export function validateArgs_ScheduleEntryLockCCAPI_setWeekDaySchedule() {
    return (__decoratedMethod, { kind }) => {
        if (kind === "method") {
            return function setWeekDaySchedule(slot, schedule) {
                v.assert(v.object({ kind: "parameter", name: "slot" }, 'ScheduleEntryLockSlotId', { "userId": v.primitive({ kind: "property", name: "userId" }, "number"), "slotId": v.primitive({ kind: "property", name: "slotId" }, "number") })(slot), v.optional({ kind: "parameter", name: "schedule" }, v.object({ kind: "parameter", name: "schedule" }, 'ScheduleEntryLockWeekDaySchedule', { "weekday": v.enum({ kind: "property", name: "weekday" }, "ScheduleEntryLockWeekday"), "startHour": v.primitive({ kind: "property", name: "startHour" }, "number"), "startMinute": v.primitive({ kind: "property", name: "startMinute" }, "number"), "stopHour": v.primitive({ kind: "property", name: "stopHour" }, "number"), "stopMinute": v.primitive({ kind: "property", name: "stopMinute" }, "number") }))(schedule));
                return __decoratedMethod.call(this, slot, schedule);
            };
        }
    };
}
export function validateArgs_ScheduleEntryLockCCAPI_getWeekDaySchedule() {
    return (__decoratedMethod, { kind }) => {
        if (kind === "method") {
            return function getWeekDaySchedule(slot) {
                v.assert(v.object({ kind: "parameter", name: "slot" }, 'ScheduleEntryLockSlotId', { "userId": v.primitive({ kind: "property", name: "userId" }, "number"), "slotId": v.primitive({ kind: "property", name: "slotId" }, "number") })(slot));
                return __decoratedMethod.call(this, slot);
            };
        }
    };
}
export function validateArgs_ScheduleEntryLockCCAPI_setYearDaySchedule() {
    return (__decoratedMethod, { kind }) => {
        if (kind === "method") {
            return function setYearDaySchedule(slot, schedule) {
                v.assert(v.object({ kind: "parameter", name: "slot" }, 'ScheduleEntryLockSlotId', { "userId": v.primitive({ kind: "property", name: "userId" }, "number"), "slotId": v.primitive({ kind: "property", name: "slotId" }, "number") })(slot), v.optional({ kind: "parameter", name: "schedule" }, v.object({ kind: "parameter", name: "schedule" }, 'ScheduleEntryLockYearDaySchedule', { "startYear": v.primitive({ kind: "property", name: "startYear" }, "number"), "startMonth": v.primitive({ kind: "property", name: "startMonth" }, "number"), "startDay": v.primitive({ kind: "property", name: "startDay" }, "number"), "startHour": v.primitive({ kind: "property", name: "startHour" }, "number"), "startMinute": v.primitive({ kind: "property", name: "startMinute" }, "number"), "stopYear": v.primitive({ kind: "property", name: "stopYear" }, "number"), "stopMonth": v.primitive({ kind: "property", name: "stopMonth" }, "number"), "stopDay": v.primitive({ kind: "property", name: "stopDay" }, "number"), "stopHour": v.primitive({ kind: "property", name: "stopHour" }, "number"), "stopMinute": v.primitive({ kind: "property", name: "stopMinute" }, "number") }))(schedule));
                return __decoratedMethod.call(this, slot, schedule);
            };
        }
    };
}
export function validateArgs_ScheduleEntryLockCCAPI_getYearDaySchedule() {
    return (__decoratedMethod, { kind }) => {
        if (kind === "method") {
            return function getYearDaySchedule(slot) {
                v.assert(v.object({ kind: "parameter", name: "slot" }, 'ScheduleEntryLockSlotId', { "userId": v.primitive({ kind: "property", name: "userId" }, "number"), "slotId": v.primitive({ kind: "property", name: "slotId" }, "number") })(slot));
                return __decoratedMethod.call(this, slot);
            };
        }
    };
}
export function validateArgs_ScheduleEntryLockCCAPI_setDailyRepeatingSchedule() {
    return (__decoratedMethod, { kind }) => {
        if (kind === "method") {
            return function setDailyRepeatingSchedule(slot, schedule) {
                v.assert(v.object({ kind: "parameter", name: "slot" }, 'ScheduleEntryLockSlotId', { "userId": v.primitive({ kind: "property", name: "userId" }, "number"), "slotId": v.primitive({ kind: "property", name: "slotId" }, "number") })(slot), v.optional({ kind: "parameter", name: "schedule" }, v.object({ kind: "parameter", name: "schedule" }, 'ScheduleEntryLockDailyRepeatingSchedule', { "weekdays": v.array({ kind: "property", name: "weekdays" }, 'ScheduleEntryLockWeekday', v.enum({ kind: "item", name: "weekdays" }, "ScheduleEntryLockWeekday")), "startHour": v.primitive({ kind: "property", name: "startHour" }, "number"), "startMinute": v.primitive({ kind: "property", name: "startMinute" }, "number"), "durationHour": v.primitive({ kind: "property", name: "durationHour" }, "number"), "durationMinute": v.primitive({ kind: "property", name: "durationMinute" }, "number") }))(schedule));
                return __decoratedMethod.call(this, slot, schedule);
            };
        }
    };
}
export function validateArgs_ScheduleEntryLockCCAPI_getDailyRepeatingSchedule() {
    return (__decoratedMethod, { kind }) => {
        if (kind === "method") {
            return function getDailyRepeatingSchedule(slot) {
                v.assert(v.object({ kind: "parameter", name: "slot" }, 'ScheduleEntryLockSlotId', { "userId": v.primitive({ kind: "property", name: "userId" }, "number"), "slotId": v.primitive({ kind: "property", name: "slotId" }, "number") })(slot));
                return __decoratedMethod.call(this, slot);
            };
        }
    };
}
export function validateArgs_ScheduleEntryLockCCAPI_setTimezone() {
    return (__decoratedMethod, { kind }) => {
        if (kind === "method") {
            return function setTimezone(timezone) {
                v.assert(v.object({ kind: "parameter", name: "timezone" }, 'Timezone', { "standardOffset": v.primitive({ kind: "property", name: "standardOffset" }, "number"), "dstOffset": v.primitive({ kind: "property", name: "dstOffset" }, "number") })(timezone));
                return __decoratedMethod.call(this, timezone);
            };
        }
    };
}
//# sourceMappingURL=ScheduleEntryLockCC._validateArgs.js.map